CSFML - C binding of the Simple and Fast Multimedia Library

CSFML

- Main Page
- Data Structures
- Files

- File List
- Globals

Functions
Shader.h File Reference
`#include <SFML/Graphics/Export.h>`
`#include <SFML/Graphics/Color.h>`
`#include <SFML/Graphics/Transform.h>`
`#include <SFML/Graphics/Types.h>`
`#include <SFML/System/InputStream.h>`
`#include <SFML/System/Vector2.h>`
`#include <SFML/System/Vector3.h>`

Go to the source code of this file.

## Functions
CSFML_GRAPHICS_API sfShader * | sfShader_createFromFile (const char *vertexShaderFilename, const char *fragmentShaderFilename)
| Load both the vertex and fragment shaders from files. More...
CSFML_GRAPHICS_API sfShader * | sfShader_createFromMemory (const char *vertexShader, const char *fragmentShader)
| Load both the vertex and fragment shaders from source codes in memory. More...
CSFML_GRAPHICS_API sfShader * | sfShader_createFromStream (sfInputStream *vertexShaderStream, sfInputStream *fragmentShaderStream)
| Load both the vertex and fragment shaders from custom streams. More...
CSFML_GRAPHICS_API void | sfShader_destroy (sfShader *shader)
| Destroy an existing shader. More...
CSFML_GRAPHICS_API void | sfShader_setFloatParameter (sfShader *shader, const char *name, float x)
| Change a float parameter of a shader. More...
CSFML_GRAPHICS_API void | sfShader_setFloat2Parameter (sfShader *shader, const char *name, float x, float y)
| Change a 2-components vector parameter of a shader. More...
CSFML_GRAPHICS_API void | sfShader_setFloat3Parameter (sfShader *shader, const char *name, float x, float y, float z)
| Change a 3-components vector parameter of a shader. More...
CSFML_GRAPHICS_API void | sfShader_setFloat4Parameter (sfShader *shader, const char *name, float x, float y, float z, float w)
| Change a 4-components vector parameter of a shader. More...
CSFML_GRAPHICS_API void | sfShader_setVector2Parameter (sfShader *shader, const char *name, sfVector2f vector)
| Change a 2-components vector parameter of a shader. More...
CSFML_GRAPHICS_API void | sfShader_setVector3Parameter (sfShader *shader, const char *name, sfVector3f vector)
| Change a 3-components vector parameter of a shader. More...
CSFML_GRAPHICS_API void | sfShader_setColorParameter (sfShader *shader, const char *name, sfColor color)
| Change a color parameter of a shader. More...
CSFML_GRAPHICS_API void | sfShader_setTransformParameter (sfShader *shader, const char *name, sfTransform transform)
| Change a matrix parameter of a shader. More...
CSFML_GRAPHICS_API void | sfShader_setTextureParameter (sfShader *shader, const char *name, const sfTexture *texture)
| Change a texture parameter of a shader. More...
CSFML_GRAPHICS_API void | sfShader_setCurrentTextureParameter (sfShader *shader, const char *name)
| Change a texture parameter of a shader. More...
CSFML_GRAPHICS_API unsigned int | sfShader_getNativeHandle (const sfShader *shader)
| Get the underlying OpenGL handle of the shader. More...
CSFML_GRAPHICS_API void | sfShader_bind (const sfShader *shader)
| Bind a shader for rendering (activate it) More...
CSFML_GRAPHICS_API sfBool | sfShader_isAvailable (void)
| Tell whether or not the system supports shaders. More...

## Function Documentation

CSFML_GRAPHICS_API void sfShader_bind | ( | const sfShader * | shader | ) |

Bind a shader for rendering (activate it)

This function is not part of the graphics API, it mustn't be used when drawing SFML entities. It must be used only if you mix sfShader with OpenGL code.

1 sfShader *s1, *s2;
2 ...
3 sfShader_bind(s1);
4 // draw OpenGL stuff that use s1...
5 sfShader_bind(s2);
6 // draw OpenGL stuff that use s2...
7 sfShader_bind(0);
8 // draw OpenGL stuff that use no shader...

Parameters

  shader | Shader to bind, can be null to use no shader

CSFML_GRAPHICS_API sfShader* sfShader_createFromFile | ( | const char * | vertexShaderFilename,
|  | const char * | fragmentShaderFilename
| ) |  |

Load both the vertex and fragment shaders from files.

This function can load both the vertex and the fragment shaders, or only one of them: pass NULL if you don't want to load either the vertex shader or the fragment shader. The sources must be text files containing valid shaders in GLSL language. GLSL is a C-like language dedicated to OpenGL shaders; you'll probably need to read a good documentation for it before writing your own shaders.

Parameters

  vertexShaderFilename | Path of the vertex shader file to load, or NULL to skip this shader
  fragmentShaderFilename | Path of the fragment shader file to load, or NULL to skip this shader

Returns
  A new sfShader object, or NULL if it failed

CSFML_GRAPHICS_API sfShader* sfShader_createFromMemory | ( | const char * | vertexShader,
|  | const char * | fragmentShader
| ) |  |

Load both the vertex and fragment shaders from source codes in memory.

This function can load both the vertex and the fragment shaders, or only one of them: pass NULL if you don't want to load either the vertex shader or the fragment shader. The sources must be valid shaders in GLSL language. GLSL is a C-like language dedicated to OpenGL shaders; you'll probably need to read a good documentation for it before writing your own shaders.

Parameters

  vertexShader | String containing the source code of the vertex shader, or NULL to skip this shader
  fragmentShader | String containing the source code of the fragment shader, or NULL to skip this shader

Returns
  A new sfShader object, or NULL if it failed

CSFML_GRAPHICS_API sfShader* sfShader_createFromStream | ( | sfInputStream * | vertexShaderStream,
|  | sfInputStream * | fragmentShaderStream
| ) |  |

Load both the vertex and fragment shaders from custom streams.

This function can load both the vertex and the fragment shaders, or only one of them: pass NULL if you don't want to load either the vertex shader or the fragment shader. The source codes must be valid shaders in GLSL language. GLSL is a C-like language dedicated to OpenGL shaders; you'll probably need to read a good documentation for it before writing your own shaders.

Parameters

  vertexShaderStream | Source stream to read the vertex shader from, or NULL to skip this shader
  fragmentShaderStream | Source stream to read the fragment shader from, or NULL to skip this shader

Returns
  A new sfShader object, or NULL if it failed

CSFML_GRAPHICS_API void sfShader_destroy | ( | sfShader * | shader | ) |

Destroy an existing shader.

Parameters

  shader | Shader to delete

CSFML_GRAPHICS_API unsigned int sfShader_getNativeHandle | ( | const sfShader * | shader | ) |

Get the underlying OpenGL handle of the shader.

You shouldn't need to use this function, unless you have very specific stuff to implement that SFML doesn't support, or implement a temporary workaround until a bug is fixed.

Parameters

  shader | Shader object

Returns
  OpenGL handle of the shader or 0 if not yet loaded

CSFML_GRAPHICS_API sfBool sfShader_isAvailable | ( | void |  | ) |

Tell whether or not the system supports shaders.

This function should always be called before using the shader features. If it returns false, then any attempt to use sfShader will fail.

Returns
  sfTrue if the system can use shaders, sfFalse otherwise

CSFML_GRAPHICS_API void sfShader_setColorParameter | ( | sfShader * | shader,
|  | const char * | name,
|  | sfColor | color
| ) |  |

Change a color parameter of a shader.

name is the name of the variable to change in the shader. The corresponding parameter in the shader must be a 4x1 vector (vec4 GLSL type).

It is important to note that the components of the color are normalized before being passed to the shader. Therefore, they are converted from range [0 .. 255] to range [0 .. 1]. For example, a sf::Color(255, 125, 0, 255) will be transformed to a vec4(1.0, 0.5, 0.0, 1.0) in the shader.

Example:

1 uniform vec4 color; // this is the variable in the shader
1 sfShader_setColorParameter(shader, "color", sfColor_fromRGB(255, 128, 0));

Parameters

  shader | Shader object
  name | Name of the parameter in the shader
  color | Color to assign

CSFML_GRAPHICS_API void sfShader_setCurrentTextureParameter | ( | sfShader * | shader,
|  | const char * | name
| ) |  |

Change a texture parameter of a shader.

This function maps a shader texture variable to the texture of the object being drawn, which cannot be known in advance. The corresponding parameter in the shader must be a 2D texture (sampler2D GLSL type).

Example:

1 uniform sampler2D current; // this is the variable in the shader
1 sfShader_setCurrentTextureParameter(shader, "current");

Parameters

  shader | Shader object
  name | Name of the texture in the shader

CSFML_GRAPHICS_API void sfShader_setFloat2Parameter | ( | sfShader * | shader,
|  | const char * | name,
|  | float | x,
|  | float | y
| ) |  |

Change a 2-components vector parameter of a shader.

name is the name of the variable to change in the shader. The corresponding parameter in the shader must be a 2x1 vector (vec2 GLSL type).

Example:

1 uniform vec2 myparam; // this is the variable in the shader
1 sfShader_setFloat2Parameter(shader, "myparam", 5.2f, 6.0f);

Parameters

  shader | Shader object
  name | Name of the parameter in the shader
  x | First component of the value to assign
  y | Second component of the value to assign

CSFML_GRAPHICS_API void sfShader_setFloat3Parameter | ( | sfShader * | shader,
|  | const char * | name,
|  | float | x,
|  | float | y,
|  | float | z
| ) |  |

Change a 3-components vector parameter of a shader.

name is the name of the variable to change in the shader. The corresponding parameter in the shader must be a 3x1 vector (vec3 GLSL type).

Example:

1 uniform vec3 myparam; // this is the variable in the shader
1 sfShader_setFloat3Parameter(shader, "myparam", 5.2f, 6.0f, -8.1f);

Parameters

  shader | Shader object
  name | Name of the parameter in the shader
  x | First component of the value to assign
  y | Second component of the value to assign
  z | Third component of the value to assign

CSFML_GRAPHICS_API void sfShader_setFloat4Parameter | ( | sfShader * | shader,
|  | const char * | name,
|  | float | x,
|  | float | y,
|  | float | z,
|  | float | w
| ) |  |

Change a 4-components vector parameter of a shader.

name is the name of the variable to change in the shader. The corresponding parameter in the shader must be a 4x1 vector (vec4 GLSL type).

Example:

1 uniform vec4 myparam; // this is the variable in the shader
1 sfShader_setFloat4Parameter(shader, "myparam", 5.2f, 6.0f, -8.1f, 0.4f);

Parameters

  shader | Shader object
  name | Name of the parameter in the shader
  x | First component of the value to assign
  y | Second component of the value to assign
  z | Third component of the value to assign
  w | Fourth component of the value to assign

CSFML_GRAPHICS_API void sfShader_setFloatParameter | ( | sfShader * | shader,
|  | const char * | name,
|  | float | x
| ) |  |

Change a float parameter of a shader.

name is the name of the variable to change in the shader. The corresponding parameter in the shader must be a float (float GLSL type).

Example:

1 uniform float myparam; // this is the variable in the shader
1 sfShader_setFloatParameter(shader, "myparam", 5.2f);

Parameters

  shader | Shader object
  name | Name of the parameter in the shader
  x | Value to assign

CSFML_GRAPHICS_API void sfShader_setTextureParameter | ( | sfShader * | shader,
|  | const char * | name,
|  | const sfTexture * | texture
| ) |  |

Change a texture parameter of a shader.

name is the name of the variable to change in the shader. The corresponding parameter in the shader must be a 2D texture (sampler2D GLSL type).

Example:

1 uniform sampler2D the_texture; // this is the variable in the shader
1 sf::Texture texture;
2 ...
3 sfShader_setTextureParameter(shader, "the_texture", texture);

It is important to note that texture must remain alive as long as the shader uses it, no copy is made internally.

To use the texture of the object being draw, which cannot be known in advance, you can use the special function sfShader_setCurrentTextureParameter:

1 sfShader_setCurrentTextureParameter(shader, "the_texture").

Parameters

  shader | Shader object
  name | Name of the texture in the shader
  texture | Texture to assign

CSFML_GRAPHICS_API void sfShader_setTransformParameter | ( | sfShader * | shader,
|  | const char * | name,
|  | sfTransform | transform
| ) |  |

Change a matrix parameter of a shader.

name is the name of the variable to change in the shader. The corresponding parameter in the shader must be a 4x4 matrix (mat4 GLSL type).

Example:

1 uniform mat4 matrix; // this is the variable in the shader
1 @todo
2 sfShader_setTransformParameter(shader, "matrix", transform);

Parameters

  shader | Shader object
  name | Name of the parameter in the shader
  transform | Transform to assign

CSFML_GRAPHICS_API void sfShader_setVector2Parameter | ( | sfShader * | shader,
|  | const char * | name,
|  | sfVector2f | vector
| ) |  |

Change a 2-components vector parameter of a shader.

name is the name of the variable to change in the shader. The corresponding parameter in the shader must be a 2x1 vector (vec2 GLSL type).

Example:

1 uniform vec2 myparam; // this is the variable in the shader
1 sfVector2f vec = {5.2f, 6.0f};
2 sfShader_setVector2Parameter(shader, "myparam", vec);

Parameters

  shader | Shader object
  name | Name of the parameter in the shader
  vector | Vector to assign

CSFML_GRAPHICS_API void sfShader_setVector3Parameter | ( | sfShader * | shader,
|  | const char * | name,
|  | sfVector3f | vector
| ) |  |

Change a 3-components vector parameter of a shader.

name is the name of the variable to change in the shader. The corresponding parameter in the shader must be a 3x1 vector (vec3 GLSL type).

Example:

1 uniform vec3 myparam; // this is the variable in the shader
1 sfVector3f vec = {5.2f, 6.0f, -8.1f};
2 sfShader_setVector3Parameter(shader, "myparam", vec);

Parameters

  shader | Shader object
  name | Name of the parameter in the shader
  vector | Vector to assign